#ナーススケジューリング 初期値作成 & 1日分数理最適化
# 日々の勤務種別人数条件を満たし、減点を最小化
#csvのフォルダをppathで指定
#scst.txtがあったら処理開始
import pandas as pd
from pulp import *
from ortoolpy import addvars, addbinvars
import numpy as np
import time
import copy
import os

def スケジュール1日(日,減点c,減点d,gr,shoki,kinj):
#    print("開始2")
    #数理最適化により1日のスケジュールを作成する(減点最小)
    #看護師,グループ,勤務種別減点
    ok=0
    grsu=4 #グループ数 
    lgr=25 #看護師人数
    開始日=6 #6日間は前月
#    gr=np.array(gr)
#    a = pd.DataFrame(gr,
#        columns=['看護師','グループ','減点0','減点1','減点2','減点3'])
    gr=np.array(gr)

# グループ変更
    変更日=[8,28,29] #新人の休暇出張多い
    if 変更日.count(日)>0:
        gr[24]=3 #グループ3に変更

    a = pd.DataFrame(gr, columns=['グループ'])
#
#  減点に加える乱数
    rr=np.random.rand(lgr,4)
    rr=(np.clip(rr,0.7,1)-0.7)/100 #0.7以下は0 30%の確立で加算

#    gr[:,2:]=gr[:,2:]+rr #3列目以降 減点に乱数を加算　
# 減点
    減点c=np.array(減点c)
    減点d=np.array(減点d)
    for k in range(4):
        a['減点'+str(k)] = 減点c[:,k]+減点d[:,k]+rr[:,k]

    a['選択0'] = addbinvars(lgr) #選択 勤務種0
    a['選択1'] = addbinvars(lgr)
    a['選択2'] = addbinvars(lgr)
    a['選択3'] = addbinvars(lgr)
    a['選択4'] = addbinvars(lgr)

    m = LpProblem() # 数理モデル

    #目的　減点計最小
    m += (lpDot(a.選択0,a.減点0)
        + lpDot(a.選択1,a.減点1)
        + lpDot(a.選択2,a.減点2)
        + lpDot(a.選択3,a.減点3))

    #初期値条件
    for i,r in a.iterrows():
        j=shoki[i][日+開始日]
        if j!=9:
            m +=r['選択'+str(j)]==1
        else:
            m +=r['選択4']==0 #出張は選択禁止
    for k in range(3):
        #トータル日勤条件
        nina= kinj[k][0][日] #下限数
        ninb= kinj[k][1][日] #上限数
        m += lpSum(a['選択'+str(k+1)]) >=nina
        m += lpSum(a['選択'+str(k+1)]) <=ninb

        #グループ別日勤条件
        for i, r in a.groupby('グループ'):
            nina= kinj[k][int(r.グループ.values[0])*2+2][日] #下限数
            ninb= kinj[k][int(r.グループ.values[0])*2+3][日] #上限数
            m += lpSum(r['選択'+str(k+1)]) >=nina
            m += lpSum(r['選択'+str(k+1)]) <=ninb


    #選択合計は1
    for _,r in a.iterrows():
        m +=lpSum([r['選択'+str(j)] for j in range(5)])==1


    # 看護師夜勤禁止組み合わせ
    禁止=[0,8] # 夜勤禁止組み合わせ
    if len(禁止)>=2:
        m +=lpSum(a.選択2[禁止])<=1 #準夜勤どちらか1名のみ
        m +=lpSum(a.選択3[禁止])<=1 #深夜勤どちらか1名のみ


#    print('グループ,勤務種別減点',gr)
#    print('必須条件',hissu)
#    print('追加条件',tsuika)
#    print('追加可能人数条件',tka)
#    print(m)
    m.solve() # ソルバーで求解
    solve_status = LpStatus[m.status]
    if solve_status == "Optimal":
        結果=""
        for _,r in a.iterrows():
            結果 +=str([k for k in range(5) if value(r['選択'+str(k)])==1][0])+','
#        print(結果)
        減点="{:.1f}".format(value(m.objective))
#        print('目的関数',減点 ,結果)
    else:
        結果="×" #回答不可
        減点=999
        print('×回答不可')
        print(m)
    return 結果,減点
    
def 不可条件計算(看護師数,開始日, 日, 日数, kha):  #in kha out 減点c(0-24,0-4)
# in 日1～ no看護師no0～24 kha(0-24,0-35)
#   日-6～ 日-1を読込、不可勤務種を計算する
    減点c=[]
    for no in range(看護師数):
        勤務 = ""; 深夜勤 = ""; 連続勤務 = ""; 日勤 = ""
        未来勤務 = ""; 未来深夜勤 = ""; 未来連続勤務 = ""; 未来日勤 = ""
    
        for j in range(max(0, 日 - 7 + 開始日),日 + 開始日):
            勤務 = 勤務 + str(kha[no][j])
            mm=3 if kha[no][j] == 3 else 0
            深夜勤 = 深夜勤 + str(mm)
            mm = 0 if kha[no][j] == 0 else 1
            連続勤務 = 連続勤務 + str(mm)
            mm = 1 if kha[no][j] == 1 else 0
            日勤 = 日勤 + str(mm)
        if 日 + 開始日 < 日数 :
            for j in range(日 + 1 + 開始日, 日 + 7 + 開始日):
                if j>=日数:
                    dat="9"
                else:
                    dat = kha[no][j]
                if dat ==9 : #未入力
                    未来勤務 = 未来勤務 + " "
                    未来深夜勤 = 未来深夜勤 + " "
                    未来連続勤務 = 未来連続勤務 + " "
                    未来日勤 = 未来日勤 + "1" #未入力は日勤とする 日勤連続無しの制限を取る
                else:
                    未来勤務 = 未来勤務 + str(dat)
                    mm = 3 if dat == 3 else 0
                    未来深夜勤 = 未来深夜勤 + str(mm)
                    mm = 0 if dat == 0  else 1
                    未来連続勤務 = 未来連続勤務 + str(mm)
                    mm = 1  if dat == 1 else 0
                    未来日勤 = 未来日勤 + str(mm)


        減点=不可計算(勤務, 深夜勤, 連続勤務, 日勤, 未来勤務, 未来深夜勤, 未来連続勤務, 未来日勤,no)
        減点c.append(減点)
    return 減点c

def 不可計算(勤務, 深夜勤, 連続勤務, 日勤, 未来勤務, 未来深夜勤, 未来連続勤務, 未来日勤, no):
    減点=[0 for i in range(4)]
    不可判断 = ""
    for j in range(6):
        if (勤務[-5:]+未来勤務[:5])[j:j+5]== "00000" : 
            不可判断 = 不可判断 + "," + "0"
    減点=減点カウント(減点,1, no, 不可判断, 0.5) #減点c(no,0-4)
    不可判断 = ""
    for j in range(5):
        if (勤務[-4:]+未来勤務[:4])[j:j+4]==  "1111" : 不可判断 = 不可判断 + "," + "1"
    減点=減点カウント(減点,2, no, 不可判断, 0.5) #減点c(no,0-4)
    不可判断 = ""
    for j in range(4):
        if (勤務[-3:]+未来勤務[:3])[j:j+3]==  "222" : 不可判断 = 不可判断 + "," + "2"
    減点=減点カウント(減点,3, no, 不可判断, 0.5) #減点c(no,0-4)
    不可判断 = ""
    for j in range(3):
        if (勤務[-2:]+未来勤務[:2])[j:j+2]==  "33" : 不可判断 = 不可判断 + "," + "3"
    減点=減点カウント(減点,4, no, 不可判断, 0.5) #減点c(no,0-4)

    #不可並び3 030修正要
    不可判断 = ""
    if 深夜勤[-2:] == "03" :
        不可判断 = 不可判断 + "," + "012" #修正 0は別で不可だが こここに加える
    if 深夜勤[-1:] == "0" and 未来深夜勤[0]== "0" : 
        不可判断 = 不可判断 + "," + "3" #他でも減点があるが加算要
    if 未来深夜勤[0:2]== "30" :
         不可判断 = 不可判断 + "," + "12" #修正 0は別で不可
    減点=減点カウント(減点,5, no, 不可判断,1) #減点c(no,0-4)

    #不可並び3 010修正要
    不可判断 = ""
    if 連続勤務[-2:] == "01" :
        不可判断 = 不可判断 + "," + "0"
    if 連続勤務[-1:]== "0" and 未来連続勤務[0]== "0" :
        不可判断 = 不可判断 + "," + "123"  #修正
    if 未来連続勤務[0:2]== "10" :
        不可判断 = 不可判断 + "," + "0"
    減点=減点カウント(減点,6, no, 不可判断,1) #減点c(no,0-4)
    不可判断 = ""
    ###となりが深夜勤ならok
    if (深夜勤[-1:] !="3" and 深夜勤[-6:].find("3") >= 0) :
        不可判断 = 不可判断 + "," + "3"
    if(未来深夜勤[0] != "3" and 未来深夜勤[0:6].find("3") >= 0) :
        不可判断 = 不可判断 + "," + "3"
    減点=減点カウント(減点,7, no, 不可判断,0.5) #減点c(no,0-4)
    不可判断 = ""
    for j in range(7):
        if (連続勤務[-6:] + 未来連続勤務[0:6])[j:j+6]== "111111" :
            不可判断 = 不可判断 + "," + "123"
    減点=減点カウント(減点,8, no, 不可判断,0.5) #減点c(no,0-4)
    不可判断 = ""
    for j in range(7):
        if (日勤[-6:] + 未来日勤[0:6])[j:j+6]== "000000" :
            不可判断 = 不可判断 + "," + "023"
    減点=減点カウント(減点,9, no, 不可判断,0.5) #減点c(no,0-4)
    #不可並び2 31
    不可判断 = ""
    if 勤務[-1:]== "3" :
        不可判断 = 不可判断 + "," + "1"
    if 未来勤務[0]== "1" :
        不可判断 = 不可判断 + "," + "3"
    減点=減点カウント(減点,10, no, 不可判断,3) #減点c(no,0-4)
    #不可並び2 34
    不可判断 = ""
    if 勤務[-1:]== "3" :
        不可判断 = 不可判断 + "," + "4"
    if 未来勤務[0] == "4" :
        不可判断 = 不可判断 + "," + "3"
    減点=減点カウント(減点,11, no, 不可判断,3) #減点c(no,0-4)
    #不可並び2 32
    不可判断 = ""
    if 勤務[-1:] == "3" :
        不可判断 = 不可判断 + "," + "2"
    if 未来勤務[0] == "2" :
        不可判断 = 不可判断 + "," + "3"
    減点=減点カウント(減点,12, no, 不可判断,0.5) #減点c(no,0-4)
    #不可並び2 21
    不可判断 = ""
    if 勤務[-1:] == "2" : 
        不可判断 = 不可判断 + "," + "1"
    if 未来勤務[0] == "1" :
        不可判断 = 不可判断 + "," + "2"
    減点=減点カウント(減点,13, no, 不可判断,3) #減点c(no,0-4)
    #不可並び2 24
    不可判断 = ""
    if 勤務[-1:] == "2" : 
        不可判断 = 不可判断 + "," + "4"
    if 未来勤務[0] == "4" :
        不可判断 = 不可判断 + "," + "2"
    減点=減点カウント(減点,14, no, 不可判断,3) #減点c(no,0-4)
    #不可並び3 301
    不可判断 = ""
    if 勤務[-2:] == "30" :
        不可判断 = 不可判断 + "," + "1"
    if 勤務[-1:] == "3" and 未来勤務[0] == "1" :
        不可判断 = 不可判断 + "," + "0"
    if 未来勤務[0:2] == "01" :
        不可判断 = 不可判断 + "," + "3"
    減点=減点カウント(減点,15, no, 不可判断,0.5) #減点c(no,0-4)
    #不可並び3 304
    不可判断 = ""
    if 勤務[-2:] == "30" : 
        不可判断 = 不可判断 + "," + "4"
    if 勤務[-1:] == "3" and 未来勤務[0] == "4" :
        不可判断 = 不可判断 + "," + "0"
    if 未来勤務[0:2] == "04" :
        不可判断 = 不可判断 + "," + "3"
    減点=減点カウント(減点,16, no, 不可判断,0.5) #減点c(no,0-4)
    return 減点

def 減点カウント(減点,outno, no, 不可判断, 減点a): #減点c(no,0-4)
    if 不可判断 != "" :
        for K in range(4):
            if 不可判断.find(str(K)) >= 0 :
                減点[K] = 減点[K] + 減点a
    return 減点

def 不可条件計算横方向(看護師数,開始日, 日,日数, kha, hih,  mdd): #in kha out 減点d(0-24,0-4)
    # mdd=1のとき 初期設定
    減点d=[]
    for no in range(看護師数):
        ct=日数減点ct作成(no,開始日, 日数, kha,日)
        減点=日数条件減点2(no, hih, ct, mdd, 日, 日数) #  入力 勤務種kk NO(看護師no, 日) HIH(0-24,0-9) CT(0-3)   出力  PP mdd=1 日割り
        減点d.append(減点)
    return 減点d

def 日数減点ct作成(no,開始日, 日数, kha,日):
    ##勤務種別の日数
    ## 看護師no no=0 ～
    ct=[0 for j in range(4)]
    for j in range(開始日,日数):
        if j!=日+開始日: #日は集計から除く
            勤務種 = kha[no][j]
            if 勤務種 < 4 :
                ct[勤務種] += 1
    return ct

def 日数条件減点2(no, hih, ct, mdd, 日, 日数):  #  入力 勤務種kk NO(看護師no) hih(0-24,0-9) CT(0-3)   出力  PP
    ## mdd=1 初期値作成 減点 0.2 他 1
    ##勤務種別 減点計算
    ## mdd=1(初期値作成) のとき 少なくても減点しない
    ##  hihは判定値セットで作成
    ## 現在上限以上であれば 1
    ## 現在下限未満であれば -1 マイナス減点
    減点=[0 for i in range(4)]

    日数a = 日数 - 開始日 #30日
    if mdd == 1 : #初期値作成
        日a = 日 + 1
    else:
        日a = 日数a
    pp = 0
    減点a = 0.2 if mdd == 1 else 1

    for j in range(4):
        pp = 0
        MMIN = hih[no][j * 2] / 日数a * 日a
        MMAX = hih[no][j * 2 + 1] / 日数a * 日a
        if ct[j] < MMIN :
            pp = -減点a
        if ct[j] >= MMAX :
            pp = 減点a 
        減点[j] = pp
    return 減点

def 初期データ作成(看護師数,開始日, 日数,gr,shoki,kinj):
    kha=copy.deepcopy(shoki)
    for 日 in range(日数-開始日):
    #    日=np.random.randint(0, 日数)  
        減点c=不可条件計算(看護師数,開始日, 日, 日数, kha)  #in kha out 減点c(0-24,0-4)
        減点d=不可条件計算横方向(看護師数,開始日, 日,日数, kha, hih,  mdd) #in kha out 減点d(0-24,0-4) mdd=1 日割条件

    #    print(減点c)
    #    print(減点d)
        

        結果,減点=スケジュール1日(日,減点c,減点d,gr,shoki,kinj)
        print(減点,結果)
        if 結果!="×": 
            # 結果をkhaに記入
            for i,da in enumerate(結果[:-1].split(",")):
                kha[i][開始日+日]=int(da)
        else:
            print(str(日)+' 不可')

    return kha

def 子作成(看護師数,開始日, 日数,gr,shoki,kinj,khak,子数):
    mdd=0 #子作成
    結果t=[] 
    ken=int(len(khak)/看護師数)
    for i in range(0,ken*看護師数,看護師数):
        khaa = copy.deepcopy(khak[i:i+看護師数]) #1個体とりだす

    #    print(減点c)
    #    print(減点d)
        for k in range(子数):
            日=np.random.randint(0, 日数-開始日) #ランダムな日
            減点c=不可条件計算(看護師数,開始日, 日, 日数, khaa)  #in kha out 減点c(0-24,0-4)
            減点d=不可条件計算横方向(看護師数,開始日, 日,日数, khaa, hih,  mdd) #in kha out 減点d(0-24,0-4) mdd=1 日割条件
#            print("i="+str(i)+" 日="+str(日))
            結果,減点=スケジュール1日(日,減点c,減点d,gr,shoki,kinj)
            出力=str(i)+','+str(日)+','+str(減点)+','+結果
            if 結果t.count(出力)==0:
                結果t.append(出力)

    return 結果t

ppath = os.getcwd() #プログラムのホルダ
print("パス"+ppath)
##ppath="C:\\phy" #excel pythonインターフェース用ホルダ
kaishi=ppath+"\scst.txt" #Excelからの開始指示
shuryo=ppath+"\scen.txt" #Excelへの終了報告


# パラメータの読み込み
#print("処理開始")

#    while ok==0:
#        try:
#初期設定 初めの6列は前月
shoki= pd.read_csv(ppath+'\shoki.csv', header=None, encoding="shift-jis").values.tolist()
#グループ 
gr = pd.read_csv(ppath+'\\gr.csv', header=None, encoding="shift-jis").values.tolist()
#勤務数条件
hih= pd.read_csv(ppath+'\\nissu.csv', header=None, encoding="shift-jis").values.tolist()

#日勤 全体　グループ(横),人数
kinj1= pd.read_csv(ppath+'\\kinj1.csv', header=None, encoding="shift-jis").values.tolist()
#日勤 全体　グループ(横),人数
kinj2= pd.read_csv(ppath+'\\kinj2.csv', header=None, encoding="shift-jis").values.tolist()
#日勤 全体　グループ(横),人数
kinj3= pd.read_csv(ppath+'\\kinj3.csv', header=None, encoding="shift-jis").values.tolist()
kinj=[]
kinj.append(kinj1)
kinj.append(kinj2)
kinj.append(kinj3)


# 処理依頼が来るまで待つ

while True: ## 繰り返し

    ok=0
    print("開始指示待ち")
    while ok==0:
        try:
            with open(kaishi) as f:
                l = f.readlines()
                com=l[0].split(",") #初期化,1(1個体)  or 子作成,2 (2個体)
                処理=com[0]
                子数=int(com[1])
                ok=1
        except:
            ok=0
            time.sleep(0.01)
    ok=0
    while ok==0: #excelとの競合でエラーとなる場合がある
        try:
            os.remove(kaishi) #依頼ファイル削除
            ok=1
        except:
            time.sleep(0.01)
    
    ##   処理開始
    看護師数=25;開始日=6; 日数=36

    if  処理=="初期値作成":
        print("初期値作成開始 減点,結果")
        #現在の計画
        mdd=1 #初期値
        khat=[]
        for j in range(子数): #指定数の初期値作成
            kha=初期データ作成(看護師数,開始日, 日数,gr,shoki,kinj)
#            print(kha)
            khat +=kha #リストの下に追加
        df= pd.DataFrame(khat) #データフレームへ
        df.to_csv(ppath+'\\nscjk.csv',index=False,header=False) #初期値csv出力
    else:
        print("子作成開始 行,日,減点,結果")
        khak= pd.read_csv(ppath+'\keikaku.csv', header=None, encoding="shift-jis").values.tolist()
        結果t=子作成(看護師数,開始日, 日数,gr,shoki,kinj,khak,子数)
        outf=ppath+"\sck.csv" #結果
        try:
            os.remove(outf) #結果ファイル削除
        except:
            pass
        with open(outf, mode='a') as f:
            for tt in 結果t:
                f.write(tt+'\n') 
                print(tt)

    #処理終了書き込み
    with open(shuryo, mode='a') as f:
        f.write('end') 
    #    break